"use strict";

function getJsName(name) {
    return name
        .replace(/\-/g, '_')
        .replace(/\//g, '_fs_')
        .replace(/\\/g, '_bs_');
}

class NameConverter {
    constructor() {
        this.variableNameMap = {};
    }

    convertName(name) {
        var map = this.variableNameMap,
            converted = map[name];

        if (converted === undefined) {
            converted = map[name] = getJsName(name);
        }
        return converted;
    }
}

var converter = new NameConverter();

module.exports = {
    NameConverter: NameConverter,
    getJsName: function (name) {
        return converter.convertName(name);
    }
};
