/*
 * Copyright (c) 2012-2016. Sencha Inc.
 */

"use strict";

var Fashion = require('../Base.js');
var Type = require('./Type.js');

class Bool extends Type {

    constructor(value) {
        super();
        this.value = !!value;
    }

    doVisit(visitor) {
        visitor.bool(this);
    }

    toString() {
        return this.value ? 'true' : 'false';
    }

    copy() {
        return new Bool(this.value);
    }
}

Fashion.apply(Bool.prototype, {
    type: 'bool',
    $isFashionBool: true,
    value: null
});

Bool.True = new Bool(true);
Bool.True.$constant = true;

Bool.False = new Bool(false);
Bool.False.$constant = true;

module.exports = Bool;
