/*
 * Copyright (c) 2012-2016. Sencha Inc.
 */

"use strict";

var Fashion = require('../Base.js');
var Type = require('./Type.js');

class ParentheticalExpression extends Type {
    constructor(value) {
        super();
        this.value = value;
    }

    toString() {
        return '(' + (this.value && this.value.toString()) + ')';
    }

    doVisit(visitor) {
        visitor.parenthetical(this);
    }
}

Fashion.apply(ParentheticalExpression.prototype, {
    value: null,
    type: 'parenthetical'
});

module.exports = ParentheticalExpression;