"use strict";

var Bool = require('./Bool.js');
var Literal = require('./Literal.js');

var Types = {
    Bool: Bool,
    Literal: Literal,
    Text: require('./Text.js'),
    Numeric: require('./Numeric.js'),
    Color: require('./Color.js'),
    ColorRGBA: require('./ColorRGBA.js'),
    ColorHSLA: require('./ColorHSLA.js'),
    ColorStop: require('./ColorStop.js'),
    LinearGradient: require('./LinearGradient.js'),
    RadialGradient: require('./RadialGradient.js'),
    List: require('./List.js'),
    Map: require('./Map.js'),
    ParentheticalExpression: require('./ParentheticalExpression.js'),
    FunctionCall: require('./FunctionCall.js'),
    Null: Literal.Null,
    None: Literal.None,
    True: Bool.True,
    False: Bool.False
};

module.exports = Types;