"use strict";

var Fashion = require('../../export/Base.js');

class BaseNode {
    constructor(token, file, line, docs) {
        if (token) {
            if (!token.$isToken) {
                Fashion.apply(this, token);
            }
            else {
                this.token = token;
                this.lineNumber = token.lineNumber;
                this.file = token.file;
                var scanner = token.scanner;
                if (this.acceptsDocs) {
                    this.docs = scanner.flushDocs();
                }
            }
        }
    }

    doVisit(visitor) {
    }

    descend(visitor) {
    }
}

Fashion.apply(BaseNode.prototype, {
    visitTarget: undefined,
    docs: undefined,
    file: undefined,
    token: undefined,
    lienNumber: undefined,
    acceptsDocs: false
});

module.exports = BaseNode;