"use strict";

var Fashion = require('../../export/Base.js');
var Type = require('../../export/type/Type.js');

class BaseSelector extends Type {
    constructor() {
        super();
    }

    clone(match, replace) {
        if (match && match === this.toString()) {
            return replace.clone();
        }
        var cloned = super.clone();
        if (this.parent) {
            cloned.setParent(this.parent.clone(match, replace));
        }
        return cloned;
    }

    hasHash(hash) {
        return this.toString() === hash;
    }

    setParent(parent) {
        this.parent = parent;
    }
}

Fashion.apply(BaseSelector.prototype, {
    parent: null,
    position: null,
    $canUnbox: false,
    skipParentPrepend: null,
});

module.exports = BaseSelector;