"use strict";

var Fashion = require('../../export/Base.js');
var BaseSelector = require('./BaseSelector.js');

class SelectorProperty extends BaseSelector {
    constructor(property, value) {
        super();
        this.property = property;
        this.value = value;
    }


    toString() {
        return this.property.toString() + ": " + this.value.toString();
    }

    doVisit(visitor) {
        visitor.selectorproperty(this);
    }

    descend(visitor) {
        this.value && visitor.visit(this.value);
    }

}

Fashion.apply(SelectorProperty.prototype, {
    type: 'selectorproperty',
    property: null,
    value: null
});

module.exports = SelectorProperty;